#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <qwidget.h>
#include <qfiledlg.h>
#include <qtstream.h>
#include <qmlined.h>
#include <qpixmap.h>
#include <kmenubar.h>
#include <ktopwidget.h>
#include <ktoolbar.h>

#include "puzzlewidget.h"
#include "newpuzzlewidget.h"
#include "questionswidget.h"
#include "editorwidget.h"

class MainWidget : public KTopLevelWidget
{
    Q_OBJECT
private:
    KMenuBar * menu;
    KToolBar * toolbar;
    QPixmap new_pixmap, open_pixmap, save_pixmap, exit_pixmap;
    PuzzleWidget * pw;
    NewPuzzleWidget * npw;
    QPopupMenu * filemenu;
    QPopupMenu * optionsmenu;
    QPopupMenu * solutionmenu;
    int savepuz_id;
    QLineEdit * title;
    QLineEdit * author;
    QLineEdit * copyright;
    QFrame * puzzleframe;
    QuestionsWidget * questions_widget;
    EditorWidget * editor_widget;
    int playmode_id,editmode_id,ShowWordCorr_id,ShowLetterCorr_id,DontShowCorr_id;
    void editorToQuestions();
    void closeDatabase();
    void resizeWidget();
    void save(QString);
    void load();
    bool puzzle_open;
public:
    MainWidget(const char * name = 0);
 
public slots:
    void openPuzzle();
    void newPuzzle();
    void npwOkClicked();
    void npwCancelClicked();
    void savePuzzleAs();
    void savePuzzle();
    void solutionMenuEnable(int,bool);
    void questionsWidgetSelect(int,bool,bool);
    void showWordCorr();
    void showLetterCorr();
    void dontShowCorr();
    void exit();
};

#endif